#!/usr/bin/env bash

conky_dir=~/.conky/
icons_dir=${conky_dir}icons/
weather_xslt=${conky_dir}weather.xslt
weather_xml=/tmp/conky_weather.xml
city_code=SZXX0017

function xsltproc_run() {
    day_number=$1
    field=$2
    moment='d'
    result=""
    if [ $# -eq 3 ]; then
        moment=$3
    fi
    result=$(xsltproc --stringparam day $day_number --stringparam moment $moment $weather_xslt $weather_xml| cut -d "|" -f$field)
    echo $result
}


function get_weather_xml() {
    c=$city_code
    w=$weather_xml
    if [ $# -ge 1 ]; then
        c=$1
    fi
    if [ $# -ge 2 ]; then
        w=$2
    fi
    wget "http://xml.weather.com/weather/local/${c}?cc=*&unit=m&dayf=7" -O ${w}
    return 0
}

function get_weather_day() {
    echo $(xsltproc_run $1 3)
}

function get_weather_icons() {
    day=$1
    moment='d'
    if [ $# -eq 2 ]; then
        moment=$2
    fi
    if [ $moment == 'd' ]; then
        cp $icons_dir$(xsltproc_run $day 6 $moment).png /tmp/weather$day.png
    elif [ $moment == 'n' ]; then
        cp $icons_dir$(xsltproc_run $day 6 $moment).png /tmp/weathern$day.png
    else
        echo "Usage: get_weather_icons day [moment]"
        echo "day is a number beatween 0 and 6"
        echo "moment is the letter 'd' or 'n'"
    fi
    return 0
}

function get_weather_min() {
    day=$1
    moment='d'
    result=""
    if [ $# -eq 2 ]; then
        moment=$2
    fi
    if [[ ( $# -ge 1 ) && ( $# -le 2 ) ]]; then
        result=$(xsltproc_run $day 4 $moment)
    else
        echo "Usage: get_weather_icons day [moment]"
        echo "day is a number beatween 0 and 6"
        echo "moment is the letter 'd' or 'n'"
    fi
    echo  $result
}

function get_weather_max() {
    day=$1
    moment='d'
    result=""
    if [ $# -eq 2 ]; then
        moment=$2
    fi
     if [[ ( $# -ge 1 ) && ( $# -le 2 ) ]]; then
        result=$(xsltproc_run $day 5 $moment)
    else
        echo "Usage: get_weather_icons day [moment]"
        echo "day is a number beatween 0 and 6"
        echo "moment is the letter 'd' or 'n'"
    fi
    echo $result
}
